<template>
  <rui-navbar>
    <template #left>
      <rui-navbar-menu>
        <router-link to="/" class="rui-menu-item">
          <strong>Rise UI</strong>
          <rui-badge size="small" class="-text--monospace">v{{ version }}</rui-badge>
        </router-link>
      </rui-navbar-menu>
    </template>

    <template #right>
      <rui-navbar-menu>
        <rui-menu-item :href="repositoryUrl" target="_blank" icon="external-link">Repository</rui-menu-item>

        <rui-toolbar label="Theme" class="-mrd">
          <rui-button caption="Light" :active="theme === 'light'" @click="toggleTheme('light')" />
          <rui-button caption="Dark" :active="theme === 'dark'" @click="toggleTheme('dark')" />
        </rui-toolbar>
      </rui-navbar-menu>
    </template>
  </rui-navbar>

  <div class="doc-page">
    <nav class="doc-page__menu">
      <rui-menu>
        <rui-menu-item :to="{name: 'readme'}">Readme</rui-menu-item>
        <rui-menu-item :to="{name: 'changelog'}">Changelog</rui-menu-item>
        <rui-menu-item :to="{name: 'licences'}">Licenses</rui-menu-item>
      </rui-menu>

      <rui-icon-text tag="h5" class="-mvd" icon="library" text="Documents" />
      <rui-menu>
        <rui-menu-item :to="{name: 'icons'}">Icons</rui-menu-item>
        <rui-menu-item :to="{name: 'i18n'}">I18n</rui-menu-item>
        <rui-menu-item :to="{name: 'testing'}">Testing</rui-menu-item>
      </rui-menu>

      <rui-icon-text tag="h5" class="-mvd" icon="library" text="Html" />
      <rui-menu>
        <rui-menu-item :to="{name: 'reset'}">Reset</rui-menu-item>
      </rui-menu>

      <rui-icon-text tag="h5" class="-mvd" icon="library" text="CSS variables" />
      <rui-menu>
        <rui-menu-item :to="{name: 'colors'}">Colors</rui-menu-item>
        <rui-menu-item :to="{name: 'fonts'}">Fonts</rui-menu-item>
        <rui-menu-item :to="{name: 'spacers'}">Spacers</rui-menu-item>
        <rui-menu-item :to="{name: 'border-radius'}">Border radius</rui-menu-item>
        <rui-menu-item :to="{name: 'z-indexes'}">Z-indexes</rui-menu-item>
        <rui-menu-item :to="{name: 'components'}">Components</rui-menu-item>
      </rui-menu>

      <rui-icon-text tag="h5" class="-mvd" icon="library" text="CSS helpers" />
      <rui-menu>
        <rui-menu-item :to="{name: 'accessibility'}">Accessibility</rui-menu-item>
        <rui-menu-item :to="{name: 'background'}">Background</rui-menu-item>
        <rui-menu-item :to="{name: 'flexbox'}">Flexbox</rui-menu-item>
        <rui-menu-item :to="{name: 'grids'}">Grids</rui-menu-item>
        <rui-menu-item :to="{name: 'input'}">Input</rui-menu-item>
        <rui-menu-item :to="{name: 'lists'}">Lists</rui-menu-item>
        <rui-menu-item :to="{name: 'margins'}">Margins</rui-menu-item>
        <rui-menu-item :to="{name: 'paddings'}">Paddings</rui-menu-item>
        <rui-menu-item :to="{name: 'text'}">Text</rui-menu-item>
        <rui-menu-item :to="{name: 'visibility'}">Visibility</rui-menu-item>
      </rui-menu>

      <rui-icon-text tag="h5" class="-mvd" icon="diamond" text="Components" />
      <rui-menu>
        <rui-search-form v-model="componentFilter" />
        <router-link v-for="component in componentsList"
                     :key="component"
                     :to="{name: 'doc', params:{page: component}}"
                     class="rui-menu-item">
          <span class="-inline-flex -flex--gap">
            <rui-icon name="file-html" :class="htmlIconClass(component)" title="Usable in raw HTML" />
            <rui-icon name="file-vuejs" :class="vueIconClass(component)" title="Has a VueJS component" />
          </span>

          <component :is="isDeprecated(component) ? 'del' : 'span'">{{ component }}</component>
        </router-link>
      </rui-menu>
    </nav>
    <main class="doc-page__content">
      <a id="__top__" />
      <router-view />

      <div class="doc-scroll-to-top">
        <rui-button href="#__top__" icon="scroll-to-top" size="large" text />
      </div>
    </main>
  </div>
</template>

<script>
import { version, repositoryUrl } from '../config.js'

export default {
  name: 'App',
  data () {
    return {
      componentFilter: '',
      version,
      repositoryUrl,
      theme: null,
    }
  },
  computed: {
    componentsList () {
      const filter = this.componentFilter.toLowerCase()
      return this.$docs.componentNames.filter(name => name.toLowerCase().includes(filter)).sort()
    },
  },
  methods: {
    toggleTheme (value) {
      if (this.theme === value) value = null
      this.theme = value

      switch (value) {
        case 'dark':
          document.body.classList.remove('rui-theme--light')
          document.body.classList.add('rui-theme--dark')
          break
        case 'light':
          document.body.classList.add('rui-theme--light')
          document.body.classList.remove('rui-theme--dark')
          break
        default:
          document.body.classList.remove('rui-theme--light', 'rui-theme--dark')
      }
    },
    htmlIconClass (component) {
      return [
        this.$getDoc(component).examples.html.length > 0 || '-text--mute',
      ]
    },
    vueIconClass (component) {
      return [
        component.match(/^Rui/) || '-text--mute',
      ]
    },
    isDeprecated (component) {
      return this.$getDoc(component).deprecated
    },
  },
  created () {
    this.$setTitle('Documentation')
  },
}
</script>
